#lang web-server

(require web-server/servlet-env
         web-server/templates
         web-server/dispatch
         xml)

;;;;Setup for stateless servlet
(define interface-version 'stateless)
(define stuffer
  (stuffer-chain
   serialize-stuffer
   (md5-stuffer (build-path (find-system-path 'home-dir) ".urls"))))

;;;;START
(define (start request)
  (layout "hello world"))

(define (layout content
                #:title [title "Noionλabs"]
                #:body-class [class ""]
                )
  (response/xexpr
   #:preamble #"<!DOCTYPE html>"
   `(html ((lang "en"))
          (head (meta ((charset "utf-8")))
                (title ,title)
                (meta ((name "description") 
                       (content "Makers of fine software for small businesses")))
                (meta ((name "author") (content "Noionλabs.com")))
                ,(comment 
                  (string-append
                   "[if lt IE 9]>"
                   "<script src=\"//html5shim.googlecode.com/svn/trunk/html5.js\">"
                   "</script>"
                   "<![endif]"))
                (link ((href "/lib/css/bootstrap.css") (rel "stylesheet")))
                (link ((href "/css/style.css") (rel "stylesheet"))))
          (body ((class ,class))
                (div ((class "topbar"))
                     (div ((class "fill"))
                          (div ((class "container"))
                               (a ((class "brand") 
                                   (href "http://noionlabs.com")) "Noionλabs.com")
                               (ul ((class "nav"))
                                   (li (a ((title "Home") (href "/#top")) "Home"))
                                   (li (a ((title "Tools to help your business") 
                                           (href "/software")) "Software"))
                                   (li (a ((title "Our open source contributions")
                                           (href "/code")) "Code"))
                                   (li (a ((title "About Us") 
                                           (href "/about")) "About"))
                                   (li (a ((title "How to contact us") 
                                           (href "/contact")) "Contact"))
                                   (li (a ((title "Login") (href "/login")) "Login"))))))
                ,content
                (script ((src "//ajax.googleapis.com/ajax/libs/jquery/1.6.3/jquery.min.js")))
                (script (string-append 
                         "window.jQuery || "
                         "document.write('"
                         "<script src=\"/libs/js/jquery-1.6.3.min.js\"><\\/script>"
                         "')"))
                (script ((src "/js/app.js")))
                (script ((src "/lib/js/bootstrap-alerts.js")))
                (script ((src "/lib/js/bootstrap-dropdown.js")))
                (script ((src "/lib/js/bootstrap-modal.js")))
                (script ((src "/lib/js/bootstrap-popover.js")))
                (script ((src "/lib/js/bootstrap-scrollspy.js")))
                (script ((src "/lib/js/bootstrap-tabs.js")))
                (script ((src "/lib/js/bootstrap-twipsy.js")))
                ))))

(serve/servlet start
               #:port 8080
               #:listen-ip #f
               #:servlet-path "/"
               #:command-line? #t
               #:stateless? #t
               #:launch-browser? #t
               #:server-root-path "htdocs"
               #:extra-files-paths (list (build-path "htdocs")))